/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-4
Name        : main.c
Author      : StalderJ
Version     : 2012-10-27v1.0
Description : Mehrdimensionales Array mit Druckmesswerten
              Ein Messfeld von Drucksensoren in einer 2D-Ebene liefert Ihnen Druckmesswerte, welche
              Sie in einem 2-dimensionalen Array speichern sollen. Die Messwerte bestehen jeweils
              aus einem Druckwert (float) und einem Einheitsvorsatz (Mega, Kilo, Zero, Milli,Mikro).
              Definieren Sie eine passende Datenstruktur für den Druckmesswert.
              Kreieren Sie dynamisch ein variables 2-dimensionales Array mit diesen Druckmesswerten
              und initialisieren diese allgemein mit den Werten wie im Beispiel unten angegeben.
              Verwenden Sie bitte Pointer-auf-Pointer, Enum und Strukturen wie in der Vorlesung
              gezeigt. Schreiben Sie zusätzlich eine Funktion, welche das Array entsprechend
              formatiert auf der Konsole ausgibt.
==================================================================================================*/
#include <stdlib.h>
#include "sensorgrid.h"

/*
 * Program control
 */
int main(int argc, char** argv) {
    
    // Sensordata Struct
    sdata_t** grid;

    const int rows = 3;
    const int cols = 4;

    // Create the array
    createGrid(&grid, rows, cols);

    // fill in some sensless data
    writeToGrid(grid, 0, 0, 0.00001);
    writeToGrid(grid, 0, 1, 0.1);
    writeToGrid(grid, 0, 2, 0.2);
    writeToGrid(grid, 0, 3, 0.3);

    writeToGrid(grid, 1, 0, 1.0);
    writeToGrid(grid, 1, 1, 1.1);
    writeToGrid(grid, 1, 2, 1.2);
    writeToGrid(grid, 1, 3, 1.3);
    
    writeToGrid(grid, 2, 0, 2.0);
    writeToGrid(grid, 2, 1, 2000.1);
    writeToGrid(grid, 2, 2, 2000000.2);
    writeToGrid(grid, 2, 3, 2.3);

    // put it out to console
    displayGrid(grid, rows, cols);

    // Free what would be free-ed anyway
    free(grid);
    return (EXIT_SUCCESS);
}
