/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-4
Name        : sensorgrid.c
Author      : StalderJ
Version     : 2012-10-27v1.0
Description : Mehrdimensionales Array mit Druckmesswerten
==================================================================================================*/
#include "sensorgrid.h"

void createGrid(sdata_t ***g1, unsigned int x, unsigned int y){
    int i;
    sdata_t **grid;
    
    // Create the x dimension of the grid
    grid = (sdata_t**) malloc(x* sizeof(sdata_t*));
    // Create an y-dimension in every x direction
    for(i=0;i < x;i++){
        *(grid+i) = (sdata_t*) malloc(y * sizeof(sdata_t));
    }
        
    // Write the address where the first grid node is stored 
    // directly to the pointer-var in the caller function
    (*g1) = grid;
}

void displayGrid(sdata_t **grid, unsigned int x, unsigned int y){
    int i, j;
    
    // Walk through every row
    for(i=0;i < x;i++){
        printf("|");
        // Walk through every element in the row
        for(j=0;j < y;j++){
            printf("%10g%c |", grid[i][j].pressure, grid[i][j].frac);
        }
        printf("\n");
    }
}

void writeToGrid(sdata_t **grid, unsigned int x, unsigned int y, float val) {  
    // Searches for a matching fraction and store value with fraction
    if (val > 1000000) {
        grid[x][y].pressure = val / (1000 * 1000);
        grid[x][y].frac = Mega;
    } else if(val > 1000) {
        grid[x][y].pressure = val / 1000;
        grid[x][y].frac = Kilo;
    } else if(val < 0.001) {
        grid[x][y].pressure = val * (1000 * 1000);
        grid[x][y].frac = Mikro;
    } else if(val < 1) {
        grid[x][y].pressure = val * 1000;
        grid[x][y].frac = Milli;
    } else {
        grid[x][y].pressure = val;
        grid[x][y].frac = Zero;
    }
}
